module tc_ds1wm (ADDR,ADS_N,CLK,EN_N,RD_N,WR_N,MR,INTR,DATA,IO);

   output [2:0] ADDR;
   output	ADS_N;
   output	CLK;
   output	EN_N;
   output	RD_N;
   output	WR_N;
   output	MR;



   input       INTR;

   inout [7:0] DATA;


   inout       IO;
   
   reg MR;
   
   reg [63:0]  ROMID;
   wire [63:0] xow_slave_romid ;
   
   wire        CLK;
   wire [7:0]  clksel;

   cpu_bfm xcpu_bfm(
   		     // Interface to DS1WM
   		     .ADDR(ADDR),
   		     .ADS_N(ADS_N),
		     .CLKSEL(clksel),
   		     .RD_N(RD_N),
   		     .WR_N(WR_N),
   		     .EN_N(EN_N),
 
   		     .INTR(INTR),
   		     .DATA(DATA)
   );


   ow_slave xow_slave(
 
   		     .IO(IO),
		     .ROMID(xow_slave_romid)

   );

   scoreboard xscoreboard(.OWS_ROMID(xow_slave_romid)); 
     
   clkgen     xclkgen(.CLK(CLK),
                      .SEL(clksel)
		     ); 
   
   // Generate System CLOCK
/*   
   parameter tclk = 125;    // clk half-period  4Mhz -> 125ns  
   
   initial begin
   
      CLK = 0;
      
      forever #tclk CLK = !CLK;
      
   end 
   
*/   
   task reset();
      begin
       MR = 1'b0;
       @(posedge CLK);
       MR = 1'b1;
       @(posedge CLK);
       MR = 1'b0;
     end  
   
   endtask
 `include "stimulus.inc"   
   

endmodule
